/****************************************************************************
 *
 * CRI Middleware SDK
 *
 * Copyright (c) 2001-2004 CRI-MW
 *
 * Appli.   : ADXT Sample Program 
 * Module   : Main function.("AHX" Playing Multi-streams)
 * File     : main.c
 *
 ****************************************************************************/
 
/***************************************************************************
 *		インクルードファイル
 *		Include file
 ***************************************************************************/

#include <stdio.h>

#include <cri_mw.h>
#include "usr/usr.h"

/***************************************************************************
 *		定数マクロ
 *		Constant Macro
 ***************************************************************************/
/*	The number of ADXT handles	*/
#define	NADXT		(4)

/*	最大チャンネル数				*/
/*	The number of maximum channels	*/
#define	MAX_CH		(2)

/*	同時再生最大ストリーム数									*/
/*	The number of maximum disc streams playing at the same time	*/
#define	MAX_STM		(NADXT)

/*	最高サンプリング周波数		*/
/*	Maximum sampling frequency	*/
#define	MAX_SFREQ	(48000)

/*	ファイル再生用ワーク領域の大きさ	*/
/*	Work area size of disc stream play	*/
#define	WKSIZE		(ADXT_CALC_WORK(MAX_CH, 1, MAX_STM, MAX_SFREQ))

/***************************************************************************
 *		処理マクロ
 *		Process MACRO
 ***************************************************************************/

/*	フラグON/OFFの反転		*/
/*	Turn over flag(ON/OFF)	*/
#define NOT_FLAG(flag)		(((flag) == OFF) ? ON : OFF)

#define UNUSED(val)			((val) = (val))

/***************************************************************************
 *		変数定義
 *		Variable Definition
 ***************************************************************************/
/*	アプリケーション構造体											*/
/*	Application structure											*/
typedef struct {
	Sint32	disp_flag;							//	Display information flag
	Sint32	pause_flag;							//	Pause flag
	ADXT	adxt[NADXT];						//	ADXT handle
	char	*fname[NADXT];						//	File name
	Sint8	work[NADXT][WKSIZE];				//	Work area
	Sint8	ahxwork[NADXT][ADXT_WORKSIZE_AHX];	//	Work area for AHX
} AP_OBJ;

/*	アプリケーションオブジェクト									*/
/*	Application Object												*/
AP_OBJ ap_obj = {
	ON,							//	Display Info.
	OFF,						//	not puase
	{NULL, NULL, NULL, NULL},		//	ADXT handle
	{"music48a.adx",	// ADX Music
	"voice24a.ahx",		// AHX Voice
	"voice24b.ahx",		// AHX Voice
	"voice24c.ahx"},	// AHX Voice
};

/***************************************************************************
 *		関数宣言
 *		Function Declaration
 ***************************************************************************/
void ap_adx_err_func(void *obj, Char8 *msg);
void ap_disp_info(AP_OBJ *ap);
void ApInitMw(AP_OBJ *ap);
void ApFinishMw(AP_OBJ *ap);
void ApStart(AP_OBJ *ap);
void ApStop(AP_OBJ *ap);
Sint32 ApExec(AP_OBJ *ap);

/***************************************************************************
 *		関数定義
 *		Function Definition
 ***************************************************************************/

/***
 *			サンプルプログラム
 *			Sample program
 ***/

/*	ADXTエラー発生時に起動する関数					*/
/*	Callback function when an error occur in ADXT	*/
void ap_adx_err_func(void *obj, Char8 *msg)
{
	UNUSED(obj);		// 未使用変数

	UsrDbgPrintf(msg);

	for (;;) {		/*	リリース時には無くす					*/
		;			/*	Delete when you release application.	*/
	}
}

/*	ミドルウェアの初期化				*/
/*	Initialize Middleware				*/
void ApInitMw(AP_OBJ *ap)
{
	UNUSED(ap);	// 未使用変数

	/*	ADXライブラリ初期化		*/
	/*	Initialize ADX library	*/
	ADXT_Init();
}

/*	アプリケーション開始処理	*/
/*	Start application		*/
void ApStart(AP_OBJ *ap)
{
	Sint32	i;

	/*	ADXT ハンドルの生成	*/
	/*	Create ADXT handle	*/
	for (i=0; i<NADXT; i++) {
		if ((ap->adxt[i]=ADXT_Create(2, ap->work[i], WKSIZE)) == NULL)
			for (;;) ;
	}

	/* AHXのの接続			*/
	/* Attach AHX			*/
	for (i=1; i<NADXT; i++) {
		ADXT_AttachAhx(ap->adxt[i], ap->ahxwork[i], ADXT_WORKSIZE_AHX);
	}
	
	/*	再生開始		*/
	/*	Start to play	*/
	for (i=0; i<NADXT; i++)
		ADXT_StartFname(ap->adxt[i], ap->fname[i]);
}

/*	アプリケーション停止処理	*/
/*	Stop application		*/
void ApStop(AP_OBJ *ap)
{
	Sint32	i;

	/* AHXの分離			*/
	/* Detach AHX			*/
	for (i=1; i<NADXT; i++) {
		ADXT_DetachAhx(ap->adxt[i]);
	}
	
	for (i=0; i<NADXT; i++) {
		/*	ADXT ハンドルの消去	*/
		/*	Destroy ADXT handle	*/
		ADXT_Destroy(ap->adxt[i]);

		ap->adxt[i] = NULL;
	}
}

/*	情報の表示			*/
/*	Display infomation	*/
void ap_disp_info(AP_OBJ *ap)
{
	char			*ststr[6] =
		{"STOP   ", "DECINFO", "PREP   ", "PLAYING", "DECEND ", "PLAYEND"};
	char			*tgstr[6] =
		{"ADX", "AHX", "AHX", "AHX"};
	Sint32			stat, sfreq, cnt, i, vol;
	Sint32			hh, mm, ss, ff;

	UsrPrintf(3, 3, "ADX Sample Program");
	UsrPrintf(3, 4, "   \"AHX\" Playing Multi-Stream");
	for (i=0; i<NADXT; i++) {
		stat = ADXT_GetStat(ap->adxt[i]);
		UsrPrintf(3, 6+i*2, "[%s] ADXT%2d: Stat=%s", tgstr[i], i, ststr[stat]);
		ADXT_GetTime(ap->adxt[i], &cnt, &sfreq);
		UsrSfcnt2time(sfreq,  cnt, &hh, &mm, &ss, &ff);
		vol = ADXT_GetOutVol(ap->adxt[i]);
		UsrPrintf(30, 6+i*2, "Time=%d:%02d:%02d.%02d %s",
								hh, mm, ss, ff, (vol == 0) ? "ON  " : "MUTE");
	}
}

/*	ADFXの再生			*/
/*	Playing the ADXT	*/
Sint32 ApExec(AP_OBJ *ap)
{
	Sint32					i;
	const USR_PERIPHERAL	*per;

	/*	情報の表示			*/
	/*	Display infomation	*/
	ap_disp_info(ap);

	per = UsrGetPeripheral(0);
	
	if (per->press & UTPAD_BUTTON1)
		ADXT_StartFname(ap->adxt[0], ap->fname[0]);
	if (per->press & UTPAD_BUTTON2)
		ADXT_StartFname(ap->adxt[1], ap->fname[1]);
	if (per->press & UTPAD_BUTTON3)
		ADXT_StartFname(ap->adxt[2], ap->fname[2]);
	if (per->press & UTPAD_BUTTON4)
		ADXT_StartFname(ap->adxt[3], ap->fname[3]);

	if (per->press & UTPAD_R) {
		for (i=0; i<NADXT; i++)
			ADXT_SetOutVol(ap->adxt[i], -999);
		ADXT_SetOutVol(ap->adxt[0], 0);
	}
	if (per->press & UTPAD_UP) {
		for (i=0; i<NADXT; i++)
			ADXT_SetOutVol(ap->adxt[i], -999);
		ADXT_SetOutVol(ap->adxt[1], 0);
	}
	if (per->press & UTPAD_RIGHT) {
		for (i=0; i<NADXT; i++)
			ADXT_SetOutVol(ap->adxt[i], -999);
		ADXT_SetOutVol(ap->adxt[2], 0);
	}
	if (per->press & UTPAD_DOWN) {
		for (i=0; i<NADXT; i++)
			ADXT_SetOutVol(ap->adxt[i], -999);
		ADXT_SetOutVol(ap->adxt[3], 0);
	}
	if (per->press & UTPAD_LEFT) {
		for (i=0; i<NADXT; i++)
			ADXT_SetOutVol(ap->adxt[i], 0);
	}

	if (per->press & UTPAD_START) {
		for (i=0; i<NADXT; i++)
			ADXT_Stop(ap->adxt[i]);
	}
	
	/* CRI Middleware Library's Server function */
	ADXM_ExecMain();

	return TRUE;
}

/*	ミドルウェアの終了					*/
/*	Finalize Middleware					*/
void ApFinishMw(AP_OBJ *ap)
{
	UNUSED(ap);	// 未使用変数

	ADXT_Finish();
}

/***
 *		メイン処理
 *		MAIN
 ***/
int main(void)
{
	AP_OBJ	*ap;
	Sint32	term_flag = OFF;
	Bool	ret;

	ap = &ap_obj;

	/*	エラーコールバック関数の登録		*/
	/*	Entry ADX error callback function	*/
	ADXM_SetCbErr(ap_adx_err_func, NULL);
	
	/*	システムの初期化										*/
	/*	Initialize Sysytem										*/
	UsrInitSystem(NULL, NULL);
	
	/*	ビデオの初期化											*/
	/*	Initialize Video Sysytem								*/
	UsrInitVideo(NULL, NULL);
	
	/*	サウンドの初期化										*/
	/*	Initialize Sound Sysytem								*/
	UsrInitSound(NULL, NULL);

	ApInitMw(ap);

	while (term_flag == OFF) {
		ApStart(ap);
		/*	cnt :frame count						*/
		/*	cnt=0:interlace	/ cnt>0:non interlace	*/
		UsrInitSync(2);
		for (;;) {
			UsrSyncFrame();
			UsrBeginDraw();
			ret = ApExec(ap);
			UsrEndDraw();

			/* 終了するかどうかの確認					*/
			/* Checks whether Usr module is terminated	*/
			if (UsrIsTerminated() == TRUE) {
				term_flag = ON;
			}
			
			if (ret == FALSE || term_flag == ON) {
				break;
			}
		}
		ApStop(ap);
	}
	/*	アプリケーション終了処理	*/
	/*	Finalize application		*/
	ApFinishMw(ap);			/*	ミドルウェアの終了				*/
							/*	Finalize Middleware				*/
	UsrFinishSound();		/*	サウンドシステムの終了処理		*/
							/*	Finalize sound system			*/
	UsrFinishVideo();		/*	ビデオの終了処理				*/
							/*	Finalize Video system			*/
	UsrFinishSystem();		/*	システムの終了処理				*/
							/*	Finalize system					*/
	return 0;
}

/* end of file */
